- AnsibleFest
- Products
- Community
- Webinars & Training
- Blog

Documentation

# gcp_storage_object – Creates a GCP Object

New in version 2.8.

- Synopsis
- Requirements
- Parameters
- Notes
- Examples
- Return Values
- Status

## Synopsis

- Upload or download a file from a GCS bucket.

## Requirements

The below requirements are needed on the host that executes this module.

- python >= 2.6
- requests >= 2.18.4
- google-auth >= 1.3.0

## Parameters

Parameter | Choices/Defaults | Comments
--- | --- | ---
action string |  | Upload or download from the bucket. Some valid choices include: "download", "upload"
auth_kind string / required | Choices: application machineaccount serviceaccount | The type of credential used.
bucket string |  | The name of the bucket.
dest path |  | Destination location of file (may be local machine or cloud depending on action).
env_type string |  | Specifies which Ansible environment you're running this module within. This should not be set unless you know what you're doing. This only alters the User Agent string for any API requests.
overwrite boolean | Choices: no yes | 'Overwrite the file on the bucket/local machine. If overwrite is false and a difference exists between GCS + local, module will fail with error' .
project string |  | The Google Cloud Platform project to use.
scopes list |  | Array of scopes to be used.
service_account_contents jsonarg |  | The contents of a Service Account JSON file, either in a dictionary or as a JSON string that represents it.
service_account_email string |  | An optional service account email address if machineaccount is selected and the user does not wish to use the default email.
service_account_file path |  | The path of a Service Account JSON file if serviceaccount is selected as type.
src path |  | Source location of file (may be local machine or cloud depending on action).
state string | Choices: present ← absent | Whether the given object should exist in GCP

## Notes

Note

- for authentication, you can set service_account_file using the c(gcp_service_account_file) env variable.
- for authentication, you can set service_account_contents using the c(GCP_SERVICE_ACCOUNT_CONTENTS) env variable.
- For authentication, you can set service_account_email using the `GCP_SERVICE_ACCOUNT_EMAIL` env variable.
- For authentication, you can set auth_kind using the `GCP_AUTH_KIND` env variable.
- For authentication, you can set scopes using the `GCP_SCOPES` env variable.
- Environment variables values will only be used if the playbook values are not set.
- The service_account_email and service_account_file options are mutually exclusive.

## Examples

    - name: create a object
      gcp_storage_object:
        action: download
        bucket: ansible-bucket
        src: modules.zip
        dest: "~/modules.zip"
        project: test_project
        auth_kind: serviceaccount
        service_account_file: "/tmp/auth.pem"
        state: present

## Return Values

Common return values are documented here, the following are the fields unique to this module:

Key | Returned | Description
--- | --- | ---
action string | success | Upload or download from the bucket.
bucket string | success | The name of the bucket.
dest string | success | Destination location of file (may be local machine or cloud depending on action).
overwrite boolean | success | 'Overwrite the file on the bucket/local machine. If overwrite is false and a difference exists between GCS + local, module will fail with error' .
src string | success | Source location of file (may be local machine or cloud depending on action).

## Status

- This module is not guaranteed to have a backwards compatible interface. [preview]
- This module is maintained by the Ansible Community. [community]

### Authors

- Google Inc. (@googlecloudplatform)

Hint

If you notice any issues in this documentation, you can edit this document to improve it.